 /*============================================================================ 
|   Copyright (C) 2003  Jonathan Harm                                           
| 
| 
|   This program is free software; you can redistribute it and/or 
|   modify it under the terms of the GNU General Public License 
|   as published by the Free Software Foundation; either version 2 
|   of the License, or (at your option) any later version. 
|   This program is distributed in the hope that it will be useful, 
|   but WITHOUT ANY WARRANTY; without even the implied warranty of 
|   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
|   GNU General Public License for more details. 
|   You should have received a copy of the GNU General Public License 
|   along with this program; if not, write to the Free Software 
|    
|   Foundation, Inc.,  
|   59 Temple Place - Suite 330 
|   Boston, MA  02111-1307, USA. 
| 
|   
| 
|                   addslash.c INITIAL for SQL Query Generator
| 
|  This program is under the GPL see http://www.gnu.org for more info 
| 
|   
|                   http://change.to/opensource 
|                   110983@lycos.com 
| 
\============================================================================*/ 
#include "querygen.h"      

char *addslash(char *string)
{

      char input_buffer[BIGBUF];    //the string that was passed to this function
      static char output_buffer[BIGBUF];   //the buffer that will contain the value that is returned
      int i;  //counter
      int shift_tally = 0; //how far output_buffer gets shifted to the right


      //copy the string to the buffer
      strcpy(input_buffer, string);


      //examine each character to determine
      //if a slash should be added
      for(i = 0; i < BIGBUF; i++)
      {
             
            if(input_buffer[i] == '\'')
            {              
               shift_tally++; //found a single quote, so the rest of the buffer is
                                  //gonna have to get shifted to the right
               output_buffer[i+shift_tally-1] = '\\';   //do this because output_buffer[i] wont always be the right spot
               output_buffer[i+shift_tally] = '\'';
             }

             if(input_buffer[i] == '\\')
             {
                shift_tally++; //same as above, excecpt this handles backslashes
                output_buffer[i+shift_tally-1] = '\\';  //do this because output_buffer[i] wont always be the right spot
                output_buffer[i+shift_tally] = '\\';

              }
                


            else if(input_buffer[i] == '\0')
            {  output_buffer[i+shift_tally] = '\0';
              break; }
       

            else
            {  //if it wasn't a ' or " then just throw it in the output_buffer
              output_buffer[i+shift_tally] = input_buffer[i];
            }

        
         }   


   return output_buffer;

}


